<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
  <documentation>
    <title>opt_result output</title>
    <authors>
      <author>Fabian Wein</author>
    </authors>
    <date>2015-01-21</date>
    <keywords>
      <keyword>SIMP</keyword>
    </keywords>
    <references>Fabian Wein, thesis</references>
    <isVerified>yes</isVerified>
    <description>Tests and illustrates output internal otimization data</description>
  </documentation>

  <fileFormats>
    <output>
      <hdf5 />
      <info />
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <region material="99lines" name="mech" />
    </regionList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <static/>
    </analysis>

    <pdeList>
      <mechanic subType="planeStrain">
        <regionList>
          <region name="mech" />
        </regionList>

        <bcsAndLoads>
           <fix name="west"> 
              <comp dof="x"/> <comp dof="y"/> 
           </fix>
           <force name="right_lower">
            <comp dof="y" value="-1"/>
          </force>
        </bcsAndLoads>
        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
          <elemResult type="mechPseudoDensity">
            <allRegions/>
          </elemResult>          
          <elemResult type="physicalPseudoDensity">
            <allRegions/>
          </elemResult>             
          <!--  What optResult_* actually means is defined within optimization as result -->
          <elemResult type="optResult_1">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_2">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_3">
            <allRegions/>
          </elemResult>
        </storeResults>
      </mechanic>
    </pdeList>
    <linearSystems>
      <system>
        <solverList>
          <directLDL/>
        </solverList>
      </system>
    </linearSystems>
  </sequenceStep>
  
  <optimization>
    <costFunction type="compliance" task="minimize" > 
      <stopping queue="999" value="0.002" type="designChange"/>
    </costFunction>
    
    <constraint type="volume" bound="upperBound" value="0.5" />
    
    <optimizer type="optimalityCondition"  maxIterations="5"/>
      
    <ersatzMaterial region="mech" material="mechanic" method="simp">
      <filters>
        <filter neighborhood="maxEdge" value="1.5" type="density"/>
     </filters>

     <design name="density" initial="0.5" lower="1e-3" upper="1.0" />
      
     <transferFunction type="simp" application="mech" param="3" />
     
     <!-- the non-filtered compliance gradient -->
     <result value="costGradient" id="optResult_1" access="plain"/>

     <!-- the filtered compliance gradient -->
     <result value="costGradient" id="optResult_2" access="smart"/>
      
     <result value="constraintGradient" detail="volume" id="optResult_3" access="plain"/>
      
     <export write="iteration" save="all"/>
      
    </ersatzMaterial>
    <commit mode="forward" stride="1"/>
  </optimization>
  
</cfsSimulation>


